Attribute VB_Name = "mdlFFT"
Attribute VB_Description = "this module include function Fast Fourier Transform"
Public Function Complex(a, b) As String
Attribute Complex.VB_Description = "this function combine <a> and <b> of real in <ab> of string type <a+ib> or <a-ib>."
Dim tComplex As String
    If (b < 0) Then tComplex = CStr(a) & "-i" & CStr(Abs(b)) Else tComplex = CStr(a) & "+i" & CStr(b)
    If (b = 0) Then tComplex = a
    Complex = tComplex
End Function
Public Function ComplexRe(ab As String)
Attribute ComplexRe.VB_Description = "this function return <a> in string type <a+ib> or <a-ib>."
Dim i As Integer
Dim tRe As Variant
    i = InStr(1, ab, "i")
    If (i = 0) Then tRe = 0 + CVar(ab)
    If (i > 0) Then tRe = 0 + CVar(Left(ab, i - 2))
    ComplexRe = tRe
End Function
Public Function ComplexIm(ab As String)
Attribute ComplexIm.VB_Description = "this function return <b> is string type <a+ib> or <a-ib>."
Dim i As Integer
Dim L As Integer
Dim tIm As Variant
    L = Len(ab)
    i = InStr(1, ab, "i")
    If (i = 0) Then tIm = 0
    If (i > 0) Then tIm = 0 + CVar(Mid(ab, i - 1, 1) & Right(ab, L - i))
    ComplexIm = tIm
End Function
Public Function ComplexMult(ByVal ac, ByVal bc) As String
Attribute ComplexMult.VB_Description = "this function mult <ac> of <bc> type string <a+ib> or <a-ib>."
Dim tac As String
Dim tbc As String
Dim a, b, c, d
Dim x, y
Dim tc As String

    tac = ac
    tbc = bc
    a = ComplexRe(tac)
    b = ComplexIm(tac)
    c = ComplexRe(tbc)
    d = ComplexIm(tbc)
    
    x = a * c - b * d
    y = a * d + b * c
    tc = Complex(x, y)
    ComplexMult = tc
End Function
Public Function ComplexDiv(ac, bc) As String
Attribute ComplexDiv.VB_Description = "this function div <ac> of <bc> type string <a+ib> or <a-ib>."
Dim tac As String
Dim tbc As String
Dim a, b, c, d
Dim x, y, t
Dim tc As String

    tac = ac
    tbc = bc
    a = ComplexRe(tac)
    b = ComplexIm(tac)
    c = ComplexRe(tbc)
    d = ComplexIm(tbc)
    
    t = c * c + d * d
    If Not (t = 0) Then
        t = 1 / t
        x = a * c + b * d
        x = x * t
        y = c * b - d * a
        y = y * t
        tc = Complex(x, y)
        ComplexDiv = tc
    End If
End Function
Public Function vector(massiv As Range) As Variant
Attribute vector.VB_Description = "this function - transformator range to vector."
Dim tMassiv As Variant
Dim tthis As Variant
Dim tVector() As Variant
Dim N As Integer
Dim i As Integer

    N = massiv.Count
    tMassiv = massiv.Value

ReDim tVector(0 To (N - 1))

    i = 0
    For Each tthis In tMassiv
        tVector(i) = tthis
        i = i + 1
    Next

    vector = tVector
    
End Function

Public Function FFTr(massiv As Range, t As Integer)
Attribute FFTr.VB_Description = "this function - interface for FFT. Work for range worksheet."
Dim N As Integer
Dim N2 As Integer
Dim tx As Variant
Dim ty As Variant
    N = massiv.Count
    N2 = 2 ^ Int(Log(N) / Log(2))
    If (N2 * 2 < N) Then N2 = N2 * 2
    tx = vector(massiv)
    ty = FFT(tx, N2, t)
    FFTr = ty
End Function
Public Function FFT(x, N As Integer, t As Integer)
Attribute FFT.VB_Description = "this function - Fast Fourier Transform. No work for range worksheets."
Dim Pi As Double
Dim i As Integer
Dim j As Integer
Dim p As Integer
Dim ll As Integer
Dim L As Integer
Dim M As Integer
Dim M1 As Integer
Dim K As Integer
Dim txy() As String
Dim tx() As Double
Dim ty() As Double
Dim c As Double
Dim s As Double
Dim t1 As Double
Dim t2 As Double
Dim t3 As Double
Dim t4 As Double
Dim u1 As Double
Dim u2 As Double
Dim u3 As Double

ReDim txy(0 To (N - 1))
ReDim tx(0 To (N - 1))
ReDim ty(0 To (N - 1))

    Pi = 4 * Atn(1)

    For i = 0 To N - 1
        txy(i) = x(i)
        tx(i) = ComplexRe(txy(i))
        ty(i) = ComplexIm(txy(i))
    Next i
    L = N
    M = N / 2
    M1 = N - 1
    While (L >= 2)
        ll = L / 2
        u1 = 1
        u2 = 0
        t1 = Pi / ll
        c = Cos(t1)
        s = (-1) * t * Sin(t1)
        For j = 0 To ll - 1 Step 1
            For i = j To N - 1 Step L
                p = i + ll
                t1 = tx(i) + tx(p)
                t2 = ty(i) + ty(p)
                t3 = tx(i) - tx(p)
                t4 = ty(i) - ty(p)
                tx(p) = t3 * u1 - t4 * u2
                ty(p) = t4 * u1 + t3 * u2
                tx(i) = t1
                ty(i) = t2
            Next i
            u3 = u1 * c - u2 * s
            u2 = u2 * c + u1 * s
            u1 = u3
        Next j
        L = L / 2
    Wend
    j = 0
    For i = 0 To M1 - 1 Step 1
        If i > j Then
            t1 = tx(j)
            t2 = ty(j)
            tx(j) = tx(i)
            ty(j) = ty(i)
            tx(i) = t1
            ty(i) = t2
        End If
        K = M
        While (j >= K)
            j = j - K
            K = K / 2
        Wend
        j = j + K
    Next i
    For i = 0 To N - 1
        If t = -1 Then
            tx(i) = tx(i) / N
            ty(i) = ty(i) / N
        End If
        txy(i) = Complex(tx(i), ty(i))
    Next i
    FFT = txy
End Function

